<!DOCTYPE html>

<html layout:decorate="~{fragments/layout}">

<head>
	<title>Add Form Category</title>
</head>

<body>
	<div layout:fragment="content">
		<center>
			<h1>Category form</h1>

			<form th:action="@{/category/save}" id="form_add" enctype="multipart/form-data" method="post"
				th:object="${category}">
				<input type="hidden" name="id" th:field="*{id}">

				<table border="2">
					<tr>
						<td>Category Initial</td>
						<td><input type="text" name="categoryInitial" th:field="*{categoryInitial}"></td>
					</tr>
					<tr>
						<td>Category Name</td>
						<td>
							<input type="text" id="categoryName" name="categoryName" th:field="*{categoryName}">
							<span id="validateCategoryName"></span>
						</td>

					</tr>

					<td><label for="imageFile">Upload Image</label></td>
					<td><input type="file" name="file" id="imageFile"></td>
					</tr>
					<tr>
						<td>Is Active</td>
						<td><input type="checkbox" name="isActive" th:field="*{isActive}"></td>
					</tr>
					<tr>
						<td colspan="2">
							<input type="submit" value="Save">
							<!--<button type="submit">Save</button>-->
						</td>
					</tr>

					</tr>
				</table>
			</form>
		</center>
		<script>
			$("#form_add").validate({
				errorClass: "text-danger",
				rules: {
					categoryInitial: {
						required: true,
						minlength: 3,
						maxlength: 10,
					},
					categoryName: {
						required: true,
						minlength: 3,
					},
					isActive: {
						required: true,
					},
					file: {
						required: true,
						typeFile: "jpg|jpeg|png",
						uploadFile: true
					}

				},
				messages: {
					categoryInitial: {
						required: "Please Fill Category Initial",
						minlength: "The name must fill at least 3 characters",
						maxlength: "The name must consist of max 10 characters"
					},
					categoryName: {
						required: "Please Fill Category Name",
						minlength: "The name must fill at least 3 characters"
					},
					isActive: {
						required: "Please Check Is Active"
					},
					file: {
						required: "",
						typeFile: "TyptypeFilePlease upload file in these format only (jpg, jpeg, png)",
						uploadFile: "Max 1 MB"
					}

				},

				submitHandler: function (form) {
					var id = $("#id").val()
					id = id == "" ? 0 : id
					var categoryName = $("#categoryName").val()
					$.ajax({
						url: '/category/checknameisexist',
						type: 'get',
						data: {categoryName: categoryName, id: id},
						dataType: 'json',
						success: function (respon) {
							if (respon) {
								$("#validateCategoryName").text("categoryName is already exsist")
								return true
							}
							else {
								fungsiSubmit(form)
							}

						}

					})

				}
			})

			function fungsiSubmit(form) {
				var formData = new FormData()

				var dataForm = $(form).serializeArray();

				$.each(dataForm, function (key, input) {
					formData.append(input.name, input.value)
				})

				var file = $("#imageFile").prop("files")
				if (file.length > 0) {
					formData.append("file", file[0])
				}
				//ajax ngirim gambar
				$.ajax({
					url: '/category/save',
					data: formData,
					type: 'post',
					dataType: "json",
					contentType: false,
					processData: false,
					cache: false,
					success: function (respon) {
						window.location.href = "/category/index"
					}
				})
			}

			jQuery.validator.addMethod("typeFile", function (value, element, param) {
				return value.match(new RegExp("." + param + "$"));
			});


			jQuery.validator.addMethod("uploadFile", function (val, element) {
				var size = element.files[0].size;
				if (size > 1048576)// checks the file more than 1 MB
				{
					return false;
				} else {
					return true;
				}
			})
		</script>
	</div>
</body>

</html>